/*****************************************************/
/*            File name : CH375.c                                                   */
/* Description : Code  for CH375 usb host , use internal firmware  */
/* Platform     : AVRStudio4.13 + WinAVR20070525  for AVR     */
/* Author       : Michael Zhang - 䲨                            */
/* Email         : sudazqb@163.com                                          */
/* MSN          : zhangqibo_1985@hotmail.com                          */
/* Date          : 2007-10-21                                                    */
/* NOT FOR COMMERCIAL USE,     ALL RIGHT RESERVED!         */
/*****************************************************/
/* Change Log:                                                                      */
/*                   20071021: original version (from old version)      */
/*****************************************************/



#include"ch375.h"
#include<util/delay.h>

/*
#define CH375_WR_H CH375_WR_PORT |= 1<<CH375_WR_BIT
#define CH375_WR_L CH375_WR_PORT &= ~(1<<CH375_WR_BIT)

#define CH375_RD_H CH375_WR_PORT |= 1<<CH375_RD_BIT
#define CH375_RD_L CH375_RD_PORT &= ~(1<<CH375_RD_BIT)

#define CH375_A0_H CH375_A0_PORT |= 1<<CH375_A0_BIT
#define CH375_A0_L CH375_A0_PORT &= ~(1<<CH375_A0_BIT)

#define CH375_CS_H CH375_CS_PORT |= 1<<CH375_CS_BIT
#define CH375_CS_L CH375_CS_PORT &= ~(1<<CH375_CS_BIT)

#define CH375_INT_ACTIVE (CH375_INT_PIN &= 1<<CH375_INT_BIT) == 0

#define CH375_TO_MCU CH375_DDR = 0x00
#define MCU_TO_CH375 CH375_DDR = 0xff

#define CH375_DAT_OUT CH375_PIN
#define CH375_DAT_IN  CH375_PORT
*/



void CH375_DelayNms(uint16 n)//ȷ
{
	while(n--)_delay_ms(1);
}


//CH375д
void CH375_WriteCMD(uint8 _CMD)
{
	//CH375_CS_L();				//ʹоƬ
	MCU_TO_CH375;
	CH375_A0_H;	
	CH375_DAT_IN = _CMD;
	CH375_WR_L;
	asm("nop;");
	asm("nop;");
	//asm("nop;");
	//asm("nop;");
	CH375_WR_H;
	_delay_us(1);
}

//CH375д
void CH375_WriteDAT(uint8 _DAT)
{
	//CH375_CS_L();
	MCU_TO_CH375;
	CH375_A0_L;
	CH375_DAT_IN = _DAT;
	CH375_WR_L;
	asm("nop;");
	asm("nop;");
	//asm("nop;");
	//asm("nop;");
	CH375_WR_H;
	//asm("nop;");
	//asm("nop;");
	//asm("nop;");
	//asm("nop;");
	//asm("nop;");
	//asm("nop;");

	//_delay_us(1);
}

//CH375
uint8 CH375_ReadDAT(void)
{
	uint8 temp;
    CH375_TO_MCU;
	CH375_A0_L;
	CH375_RD_L;
	asm("nop;");
	asm("nop;");
	//asm("nop;");
	//asm("nop;");
	temp = CH375_DAT_OUT;		//д
	CH375_RD_H;
	//asm("nop;");
	//asm("nop;");
	//asm("nop;");
	//asm("nop;");
	//asm("nop;");
	//asm("nop;");

	//_delay_us(1);
	return temp;
}

//CH375ȴжϣж״̬
uint8 CH375_WaitInterrupt()
{
	uint8 temp;
	while(!CH375_INT_ACTIVE);
	CH375_WriteCMD(GET_STATUS);
	temp = CH375_ReadDAT();
	return temp;
}

uint8 CH375_WaitInterrupt_NEW()//ʱ
{
	uint8 temp;
	uint32 retry =0;
	while((!CH375_INT_ACTIVE) && (retry++ < 0x1ffff));
	if(retry == 0x20000)return 0xff;
	CH375_WriteCMD(GET_STATUS);
	temp = CH375_ReadDAT();
	return temp;
}

//ʼU
uint8 CH375_IniDisk(void)
{
	//printf(("\r\n375 reset"));
	CH375_CS_L;
	CH375_WriteCMD(RESET_ALL);			//λȫ
	CH375_DelayNms(100);					//ʱ40ms
	CH375_WriteCMD(CHECK_EXIST);		//оƬǷ
	CH375_WriteDAT(0x55);				//0x55 ȡΪ0xaa
	if(CH375_ReadDAT() != 0xaa){CH375_CS_H;return 1;}//˳
	CH375_WriteCMD(SET_USB_MODE);		//CH375ģʽ
	CH375_WriteDAT(HOST_ACTIVE_EOF);	//ģʽԶEOF
	_delay_us(40);					//ʱ20us
	if(CH375_WaitInterrupt() != USB_INT_CONNECT){CH375_CS_H;return 1;}//ɹ𷵻
	CH375_DelayNms(500);				//ʱ500msU׼
	CH375_WriteCMD(DISK_INIT);			//ʼU
	if(CH375_WaitInterrupt() != USB_INT_SUCCESS){CH375_CS_H;return 1;}//ɹ˳
	CH375_CS_H;
	return 0;							//0
}

//CH375һ //
uint8 CH375_ReadOneSector(uint32 LBA,uint8 *buffer)
{
	uint8 cnt;					//8ζ		
	uint8 temp;						//ݳ
retry:
	CH375_CS_L;
	CH375_WriteCMD(DISK_READ);		//
	CH375_WriteDAT(LBA);			//Ŀĵַ
	CH375_WriteDAT(LBA>>8);
	CH375_WriteDAT(LBA>>16);
	CH375_WriteDAT(LBA>>24);
	CH375_WriteCMD(1);
	cnt = 8;				//һ
	while(cnt--)
	{
		if(CH375_WaitInterrupt_NEW() != USB_INT_DISK_READ)break;	//ȴ 
		CH375_WriteCMD(RD_USB_DATA);							//
		temp = CH375_ReadDAT();									//ݳ
		while(temp--)*buffer++ = CH375_ReadDAT();				//ζ
		CH375_WriteCMD(DISK_RD_GO);								//
	} 
	if(cnt != 0xff)//豸ʱ¸λ
	{
		CH375_CS_H;
		CH375_IniDisk();//λ
		goto retry;
	}
	if(CH375_WaitInterrupt_NEW() != USB_INT_SUCCESS){CH375_CS_H;return 1;}//򷵻1
	CH375_CS_H;
	return 0;														//0
}

//CH375дһ
uint8 CH375_WriteOneSector(uint32 LBA,uint8 *buffer)
{
	uint8 cnt = 8;						//8ͳ
	uint8 temp = 64;					//ÿ64ֽ
	CH375_CS_L;
	CH375_WriteCMD(DISK_WRITE);			//д
	CH375_WriteDAT(LBA);				//Ŀĵַ
	CH375_WriteDAT(LBA>>8);
	CH375_WriteDAT(LBA>>16);
	CH375_WriteDAT(LBA>>24);
	CH375_WriteCMD(1);					//дһ
	while(cnt--)
	{
		if(CH375_WaitInterrupt() != USB_INT_DISK_WRITE)break;		//ȴ 
		CH375_WriteCMD(WR_USB_DATA7);								//д
		CH375_WriteDAT(64);											//趨ݳ
		while(temp--)CH375_WriteDAT(*buffer++);						//ͳ
		CH375_WriteCMD(DISK_WR_GO);									//д
	}
	if(cnt != 0xff || CH375_WaitInterrupt() != USB_INT_SUCCESS){CH375_CS_H;return 1;}//˳
	CH375_CS_H;
	return 0;														//0
}


uint32 CH375_ReadDiskSize(void)
{
	uint8 buffer[8];
	uint8 cnt;
	uint8 i;
	uint32 temp1, temp2;
	CH375_CS_L;
	CH375_WriteCMD(DISK_SIZE);
	if(CH375_WaitInterrupt() != USB_INT_SUCCESS)
	{
		CH375_CS_L;
		return 0;
	}
	CH375_WriteCMD(RD_USB_DATA);
	cnt = CH375_ReadDAT();
	for(i=0;i<cnt;i++)buffer[i] = CH375_ReadDAT();
	CH375_CS_H;

	/* data format is big endian */	
	temp1 =   (uint32)buffer[0]<<24;
	temp1 += (uint32)buffer[1]<<16;
	temp1 += (uint32)buffer[2]<<8;
	temp1 += (uint32)buffer[3]<<0;
	
	temp2 =   (uint32)buffer[4]<<24;
	temp2 += (uint32)buffer[5]<<16;
	temp2 += (uint32)buffer[6]<<8;
	temp2 += (uint32)buffer[7]<<0;

	return temp1 * temp2;
}

uint8 CH375_CheckExist(void)
{
	CH375_CS_L;
	CH375_WriteCMD(RESET_ALL);			//λȫ
	CH375_DelayNms(40);					//ʱ40ms
	CH375_WriteCMD(CHECK_EXIST);		//оƬǷ
	CH375_WriteDAT(0x55);				//0x55 ȡΪ0xaa
	if(CH375_ReadDAT() != 0xaa){CH375_CS_H;return 0;}//˳
	CH375_CS_L;
	return 1;
}
/*
//cs ŵĺ궨
#define CH375_CS_H() CH375_CS_PORT |=  (1<<CH375_CS_BIT)
#define CH375_CS_L() CH375_CS_PORT &= ~(1<<CH375_CS_BIT)

void CH375_DelayNus(uint16 n)//ȷ
{
	while(n--)asm("nop;");
}

void CH375_DelayNms(uint16 n)//ȷ
{
	while(n--)CH375_DelayNus(1000);
}

void CH375_PortIni()
{
	MCUCR |= (1<<SRE);							//ʹ
	CH375_CS_DDR  |= (1<<CH375_CS_BIT);		//cs
	CH375_CS_PORT |= (1<<CH375_CS_BIT);
	CH375_INT_DDR  &= ~(1<<CH375_INT_BIT);		//int
	CH375_INT_PORT |=  (1<<CH375_INT_BIT);
}

//CH375д
void CH375_WriteCMD(uint8 _CMD)
{
	//CH375_CS_L();				//ʹоƬ
	CH375_CMD_PORT = _CMD;		//д
	//CH375_CS_H();				//ֹоƬ
//	CH375_DelayNus(2);			//ʱ
	asm("nop;");
	asm("nop;");
	asm("nop;");
	asm("nop;");
//	asm("nop;");
//	asm("nop;");
//	asm("nop;");
//	asm("nop;");
//	asm("nop;");
//	asm("nop;");
}

//CH375д
void CH375_WriteDAT(uint8 _DAT)
{
	//CH375_CS_L();
	CH375_DAT_PORT = _DAT;
	//CH375_CS_H();
	//CH375_DelayNus(2);
	asm("nop;");
	asm("nop;");
	asm("nop;");
	asm("nop;");
//	asm("nop;");
//	asm("nop;");
//	asm("nop;");
//	asm("nop;");
//	asm("nop;");
//	asm("nop;");
}

//CH375
uint8 CH375_ReadDAT(void)
{
	uint8 temp;
	asm("nop;");
	asm("nop;");
	asm("nop;");
	asm("nop;");
//	asm("nop;");
//	asm("nop;");
//	asm("nop;");
//	asm("nop;");
//	asm("nop;");
//	asm("nop;");
	//CH375_DelayNus(2);
	//CH375_CS_L();
	temp = CH375_DAT_PORT;
	//CH375_CS_H();
	return temp;
}

//CH375ȴжϣж״̬
uint8 CH375_WaitInterrupt()
{
	uint8 temp;
	while(CH375_INT_PIN & (1<<CH375_INT_BIT));
	CH375_WriteCMD(GET_STATUS);
	temp = CH375_ReadDAT();
	return temp;
}

uint8 CH375_WaitInterrupt_NEW()//ʱ
{
	uint8 temp;
	uint16 retry =0;
	while((CH375_INT_PIN & (1<<CH375_INT_BIT)) && retry++ < 0xffff);
	if(retry == 0x0)return 0xff;
	CH375_WriteCMD(GET_STATUS);
	temp = CH375_ReadDAT();
	return temp;
}

//ʼU
uint8 CH375_IniDisk(void)
{
	CH375_CS_L();
	CH375_WriteCMD(RESET_ALL);			//λȫ
	CH375_DelayNms(40);					//ʱ40ms
	CH375_WriteCMD(CHECK_EXIST);		//оƬǷ
	CH375_WriteDAT(0x55);				//0x55 ȡΪ0xaa
	if(CH375_ReadDAT() != 0xaa){CH375_CS_H();return 1;}//˳
	CH375_WriteCMD(SET_USB_MODE);		//CH375ģʽ
	CH375_WriteDAT(HOST_ACTIVE_EOF);	//ģʽԶEOF
	CH375_DelayNus(20);					//ʱ20us
	if(CH375_WaitInterrupt() != USB_INT_CONNECT){CH375_CS_H();return 1;}//ɹ𷵻
	//CH375_DelayNms(50);				//ʱ500msU׼
	CH375_WriteCMD(DISK_INIT);			//ʼU
	if(CH375_WaitInterrupt() != USB_INT_SUCCESS){CH375_CS_H();return 1;}//ɹ˳
	CH375_CS_H();
	return 0;							//0
}

//CH375һ //
uint8 CH375_ReadOneSector(uint32 LBA,uint8 *buffer)
{
	uint8 cnt;					//8ζ		
	uint8 temp;						//ݳ
retry:
	CH375_CS_L();
	CH375_WriteCMD(DISK_READ);		//
	CH375_WriteDAT(LBA);			//Ŀĵַ
	CH375_WriteDAT(LBA>>8);
	CH375_WriteDAT(LBA>>16);
	CH375_WriteDAT(LBA>>24);
	CH375_WriteCMD(1);
	cnt = 8;				//һ
	while(cnt--)
	{
		if(CH375_WaitInterrupt_NEW() != USB_INT_DISK_READ)break;	//ȴ 
		CH375_WriteCMD(RD_USB_DATA);							//
		temp = CH375_ReadDAT();									//ݳ
		while(temp--)*buffer++ = CH375_ReadDAT();				//ζ
		CH375_WriteCMD(DISK_RD_GO);								//
	} 
	if(cnt != 0xff)//豸ʱ¸λ
	{
		CH375_CS_H();
		CH375_IniDisk();//λ
		goto retry;
	}
	if(CH375_WaitInterrupt_NEW() != USB_INT_SUCCESS){CH375_CS_H();return 1;}//򷵻1
	CH375_CS_H();
	return 0;														//0
}

//CH375дһ
uint8 CH375_WriteOneSector(uint32 LBA,uint8 *buffer)
{
	uint8 cnt = 8;						//8ͳ
	uint8 temp = 64;					//ÿ64ֽ
	CH375_CS_L();
	CH375_WriteCMD(DISK_WRITE);			//д
	CH375_WriteDAT(LBA);				//Ŀĵַ
	CH375_WriteDAT(LBA>>8);
	CH375_WriteDAT(LBA>>16);
	CH375_WriteDAT(LBA>>24);
	CH375_WriteCMD(1);					//дһ
	while(cnt--)
	{
		if(CH375_WaitInterrupt() != USB_INT_DISK_WRITE)break;		//ȴ 
		CH375_WriteCMD(WR_USB_DATA7);								//д
		CH375_WriteDAT(64);											//趨ݳ
		while(temp--)CH375_WriteDAT(*buffer++);						//ͳ
		CH375_WriteCMD(DISK_WR_GO);									//д
	}
	if(cnt != 0xff || CH375_WaitInterrupt() != USB_INT_SUCCESS){CH375_CS_H();return 1;}//˳
	CH375_CS_H();
	return 0;														//0
}*/


/* This is the end of file CH375.c */
