#include "LCD.H"

#define DefaultRow		0xc0
#define DefaultColumn	0x40
#define DefaultPage		0xb8                                                            

#define uchar unsigned char
#define uint unsigned int

uchar Dis_Buf[1024];

uchar AREA=1;
uchar error_flag=0;



//////////////////ײ㺯////////////////////////////////////////////////////////////////


/*************************************************/
/*      LCDʼ                            */
/*************************************************/
void InitialLcd(void)
{
	MCUCR |= (1<<SRE);             //ʹ
	//XMCRA |= (1<<SRW00)|(1<<SRW01);//ȴ

	SET_RST_OUTPUT();			//RSTΪ
	SET_CSA_OUTPUT();			//CSAΪ		
	SET_CSB_OUTPUT();			//CSBΪ
	SET_CSA();					//CSA CSBΪЧ״̬
	SET_CSB();
	CLR_RST();					//RSTλ
	LCDDelay(255);				//ʱ
	SET_RST();					//
	LCDDelay(255);				//ʱ
    ShowLcd(0x00);				//ʾ
	ClearDisBuf(0x00);				//
	UpdateDis();
	LocateLcdPageColumn(0x00,0x00);//λʾ		
	ShowLcd(0x01 );				//ʾ
}


/*************************************************/
/*      æ ȫֱerror_flag    */
/*************************************************/
void BusyOrNot()
{
	uchar _data,i=0;
	while(1)
	{
		_data = CMD_READ;      //״̬
		_data=0x90 & _data;
		if(_data==0x00) break;//Ƚ
		if(i++==255){error_flag=1;return;}//ʱ
	}
}

/*************************************************/
/*      д                             */
/*************************************************/
void WriteCommandToRightArea(uchar Command)
{
	CLR_CSB();			//ѡ
	BusyOrNot();		//æ
	CMD_WRITE = Command;//д
	SET_CSB();			//ͷ
}

/*************************************************/
/*      д                             */
/*************************************************/
void WriteDataToRightArea(uchar _Data)
{
	CLR_CSB();			//ѡ
	BusyOrNot();		//æ
	DAT_WRITE = _Data;	//д
	SET_CSB();			//ͷ
}

/*************************************************/
/*      д                             */
/*************************************************/
void WriteCommandToLeftArea(uchar Command)
{
	CLR_CSA();			//ѡ
	BusyOrNot();		//æ
	CMD_WRITE = Command;//д
	SET_CSA();			//ͷ
}

/*************************************************/
/*      д                             */
/*************************************************/
void WriteDataToLeftArea(uchar _Data)
{
	CLR_CSA();			//ѡ
	BusyOrNot();		//æ
	DAT_WRITE = _Data;	//д
	SET_CSA();			//ͷ
}




/*************************************************/
/*      LCD                                  */
/*************************************************/
void ClearDisBuf(uchar val)
{
	uint i;
	for(i=0;i<1024;i++)Dis_Buf[i]=val;
}

/*************************************************/
/*      ʾ                                 */
/*************************************************/
void UpdateDis(void)
{
	uchar Page,Column;
	uchar *p = Dis_Buf;
	for(Page=0,Column=0;Page<8;Page++)
	{
		LocateLcdPageColumn(Page,Column);//λҳ
		for(Column=0;Column<64;Column++)WriteDataToRightArea(*p++);//д
		LocateLcdPageColumn(Page,Column);//λҳ
		for(Column=64;Column<128;Column++)WriteDataToLeftArea(*p++);//д
	}
	LocateLcdPageColumn(0x00,0x00);//λʾ		
	ShowLcd(0x01 );				//ʾ
}


/*************************************************/
/*      LCDʾ                              */
/*************************************************/
void ShowLcd(uchar on)//LCDʾأon=0x00;on=0x01,.
{
	uchar temp;
	temp=0x3E;			//00111110B
	temp+=on;
	WriteCommandToRightArea(temp);
	WriteCommandToLeftArea(temp);
}

//λ
void LocateLcdColumn(uchar Column)
{
	uchar temp;
	temp = DefaultColumn;//01000000B
	temp += Column;					   
	if(Column>63)
	{
		temp -= 64;		        //Ϊдָʾ
		WriteCommandToLeftArea(temp); //λ
	}
	else WriteCommandToRightArea(temp);//λ	   
}

//λҳ
void LocateLcdPage(uchar Page)
{
	uchar temp;
	temp=DefaultPage;					//10111000B;
	temp+=Page;
	WriteCommandToRightArea(temp);
	WriteCommandToLeftArea(temp);
}

//λҳ
void LocateLcdPageColumn(uchar Page,uchar Column)
{
	LocateLcdPage(Page);
	LocateLcdColumn(Column);
}



////////////////Ϊײ㺯///////////////////////////////////////////////////////////////

/*************************************************/
/*    һ  x,yΪ valΪ01      */
/*************************************************/
void OnePixel(uchar x,uchar y,uchar val)
{
	uchar *p = &Dis_Buf[ ((y>>3)<<7) + x ];//ҵӦֽ
	if(val)*p |= (1<<(y%8));		//޸ĶӦλ
	else *p &= ~(1<<(y%8));
}

unsigned char ReadPixel(uchar x,uchar y)
{
	uchar *p = &Dis_Buf[ ((y>>3)<<7) + x ];//ҵӦֽ
	if(*p & (1<<(y%8)))return 1;
	else return 0;
}

void LCDDelay(uint n)
{
	while(n--)asm("nop;");
}


