/*****************************************************/
/*            File name : LCD_APP.h                                              */
/* Description : head file of LCD_APP.c                                      */
/* Platform     : AVRStudio4.13 + WinAVR20070525  for AVR     */
/* Author       : Michael Zhang - 䲨                            */
/* Email         : sudazqb@163.com                                          */
/* MSN          : zhangqibo_1985@hotmail.com                          */
/* Date          : 2007-2-2                                                    */
/* NOT FOR COMMERCIAL USE,     ALL RIGHT RESERVED!         */
/*****************************************************/
/* Change Log:                                                                      */
/*                   20071109: add a faster display function for 3310 */
/*                   20071021: add 6*12 tag display                         */
/*                   20070202: original version                                 */
/*****************************************************/

#ifndef __LCD_APP_H__
#define __LCD_APP_H__

#include"LCD_ASCII.h"
#include"LCD_GBK.h"

#define MAX_X 84
#define MAX_Y 48

extern unsigned char LCD_print12_fast(unsigned int x,unsigned int y,unsigned char *str);

extern void Print_ICON_12(unsigned int x,unsigned int y,unsigned char ch);  /* 12*12 */
extern void Print_ICON1_12(unsigned int x,unsigned int y,unsigned char ch); /* 6*12 */
extern unsigned char LCD_print12_P(unsigned int x,unsigned int y,const char *str);
extern unsigned char LCD_print16_P(unsigned int x,unsigned int y,const char *str);
extern unsigned char LCD_print12(unsigned int x,unsigned int y,unsigned char *str);
extern unsigned char LCD_print16(unsigned int x,unsigned int y,unsigned char *str);
extern unsigned char LCD_print_unicode16(unsigned int x,unsigned int y,unsigned int *str);
extern unsigned char LCD_print_unicode12(unsigned int x,unsigned int y,unsigned int *str);

#endif
